<template>
  <div class="q-pa-md">
    <q-table
      title="User"
      :columns="columns"
      :rows="user"
      row-key="name"
    >

      <template v-slot:header="props">
        <q-tr :props="props">
          <q-th auto-width />

          <q-th
            v-for="col in props.cols"
            :key="col.name"
            :props="props"
          >
            {{ col.label }}
          </q-th>
        </q-tr>
      </template>

      <template v-slot:body="props">
        <q-tr :props="props">
          <q-td auto-width >
            <q-toggle v-model="props.expand" checked-icon="add" unchecked-icon="remove" v-if="props.row.squard"/>
          </q-td>

          <q-td
            v-for="col in props.cols"
            :key="col.name"
            :props="props"
          >
            {{ col.value }}
          </q-td>
        </q-tr>
        <q-tr v-show="props.expand" :props="props">
          <q-td colspan="100%">
            <div class="text-left" v-for="i in props.row.squard" :key="i.name">Squard: {{ i.name }}.</div>
          </q-td>
        </q-tr>
      </template>

    </q-table>
  </div>
</template>

<script>

const columns = [
  {
    name: 'name',
    label: 'Name',
    align: 'left',
    field: 'name',
    sortable: true
  },
  { name: 'age', align: 'left', label: 'Age', field: 'age', sortable: true },
  { name: 'hobbies',align: 'left', label: 'Hobbies', field: 'hobbies', sortable: true },
]


export default ({
  name: "MainLayout",
  data() {
    return{
      user: {},
      columns,
    }
  },
  created() {
    this.$store.commit('user/defaultUser')
    this.getUsers()
  },
  methods: {
    getUsers() {
      this.$store.dispatch('user/fetchUsers')
      .then(response => {
        response.data.data.forEach(d => {
          this.$store.commit('user/setUser', d)
          this.user = this.$store.getters['user/getUser']
          console.log(this.user)
        });
      }) 
      .catch((err) => {
        console.log(err)
      })
    }
  }
});
</script>
